diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/irq.c linux-2.6.6-ia64-adeos/arch/ia64/kernel/irq.c
--- linux-2.6.6-ia64/arch/ia64/kernel/irq.c	2004-06-13 12:29:08.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/irq.c	2004-06-17 11:45:44.000000000 +0200
@@ -432,6 +432,29 @@ void enable_irq(unsigned int irq)
 }
 EXPORT_SYMBOL(enable_irq);
 
+#ifdef CONFIG_ADEOS_CORE
+
+/* Rollback vanilla changes from 2.6.3 -> 2.6.4: we _do_ need the IRQ
+   enter/exit stuff to be done by do_IRQ(), and not from
+   ia64_handle_irq(). Doing otherwise causes havoc. */
+
+static inline void
+irq_enter (void)
+{
+	preempt_count() += HARDIRQ_OFFSET;
+}
+
+static inline void
+irq_exit (void)
+{
+	preempt_count() -= IRQ_EXIT_OFFSET;
+	if (!in_interrupt() && local_softirq_pending())
+		do_softirq();
+	preempt_enable_no_resched();
+}
+
+#endif /* CONFIG_ADEOS_CORE */
+
 /*
  * do_IRQ handles all normal device IRQ's (the special
  * SMP cross-CPU interrupts have their own specific
@@ -455,17 +478,31 @@ unsigned int do_IRQ(unsigned long irq, s
 	unsigned int status;
 	int cpu;
 
+#ifdef CONFIG_ADEOS_CORE
+	irq_enter();
+#endif /* CONFIG_ADEOS_CORE */
 	cpu = smp_processor_id(); /* for CONFIG_PREEMPT, this must come after irq_enter()! */
 
 	kstat_cpu(cpu).irqs[irq]++;
 
 	if (desc->status & IRQ_PER_CPU) {
 		/* no locking required for CPU-local interrupts: */
+#ifdef CONFIG_ADEOS_CORE
+	    if (!adp_pipelined)
+#endif /* CONFIG_ADEOS_CORE */
 		desc->handler->ack(irq);
+#ifdef CONFIG_ADEOS_CORE
+		if (likely(adp_pipelined && __adeos_tick_irq == irq))
+		    action_ret = handle_IRQ_event(irq, &__adeos_tick_regs, desc->action);
+		else
+#endif /* CONFIG_ADEOS_CORE */
 		action_ret = handle_IRQ_event(irq, regs, desc->action);
 		desc->handler->end(irq);
 	} else {
 		spin_lock(&desc->lock);
+#ifdef CONFIG_ADEOS_CORE
+		if (!adp_pipelined)
+#endif /* CONFIG_ADEOS_CORE */
 		desc->handler->ack(irq);
 		/*
 		 * REPLAY is when Linux resends an IRQ that was dropped earlier
@@ -507,6 +544,11 @@ unsigned int do_IRQ(unsigned long irq, s
 		 */
 		for (;;) {
 			spin_unlock(&desc->lock);
+#ifdef CONFIG_ADEOS_CORE
+			if (likely(adp_pipelined && __adeos_tick_irq == irq))
+			    action_ret = handle_IRQ_event(irq,&__adeos_tick_regs,desc->action);
+			else
+#endif /* CONFIG_ADEOS_CORE */
 			action_ret = handle_IRQ_event(irq, regs, action);
 			spin_lock(&desc->lock);
 			if (!noirqdebug)
@@ -524,6 +566,9 @@ unsigned int do_IRQ(unsigned long irq, s
 		desc->handler->end(irq);
 		spin_unlock(&desc->lock);
 	}
+#ifdef CONFIG_ADEOS_CORE
+	irq_exit();
+#endif /* CONFIG_ADEOS_CORE */
 	return 1;
 }
 
@@ -998,6 +1043,32 @@ static int irq_affinity_write_proc (stru
 	return full_count;
 }
 
+#ifdef CONFIG_ADEOS_CORE
+
+unsigned long __adeos_set_irq_affinity (unsigned irq, unsigned long cpumask)
+
+{
+    unsigned long oldmask = irq_affinity[irq];
+
+    if (irq_descp(irq)->handler->set_affinity == NULL)
+	return 0;
+
+    if (cpumask == 0)
+	return oldmask; /* Return mask value -- no change. */
+
+    cpumask &= cpu_online_map;
+
+    if (cpumask == 0 || irq_descp(irq)->handler->set_affinity == NULL)
+	return 0;	/* Error -- bad mask value or non-routable IRQ. */
+
+    irq_affinity[irq] = cpumask;
+    irq_descp(irq)->handler->set_affinity(irq,cpumask);
+
+    return oldmask;
+}
+
+#endif /* CONFIG_ADEOS_CORE */
+
 #endif /* CONFIG_SMP */
 
 static int prof_cpu_mask_read_proc (char *page, char **start, off_t off,
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/irq_ia64.c linux-2.6.6-ia64-adeos/arch/ia64/kernel/irq_ia64.c
--- linux-2.6.6-ia64/arch/ia64/kernel/irq_ia64.c	2004-06-13 12:55:53.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/irq_ia64.c	2004-06-17 11:45:44.000000000 +0200
@@ -57,6 +57,8 @@ __u8 isa_irq_to_vector_map[16] = {
 };
 EXPORT_SYMBOL(isa_irq_to_vector_map);
 
+#ifndef CONFIG_ADEOS_CORE
+
 static inline void
 irq_enter (void)
 {
@@ -72,6 +74,8 @@ irq_exit (void)
 	preempt_enable_no_resched();
 }
 
+#endif /* !CONFIG_ADEOS_CORE */
+
 int
 assign_irq_vector (int irq)
 {
@@ -90,9 +94,24 @@ extern unsigned int do_IRQ(unsigned long
  * interrupt. This branches to the correct hardware IRQ handler via
  * function ptr.
  */
+#ifdef CONFIG_ADEOS_CORE
+
+/* The ifdef hell in the original implementation is required here,
+   because we don't want to miss changes from any later kernel
+   revisions when patching Adeos in, like it could happen with an
+   independent rewrite of this routine aside of the original code. */
+
+int
+ia64_handle_irq (ia64_vector vector, struct pt_regs *regs)
+{
+    adeos_declare_cpuid;
+
+    adeos_load_cpuid();
+#else /* !CONFIG_ADEOS_CORE */
 void
 ia64_handle_irq (ia64_vector vector, struct pt_regs *regs)
 {
+#endif /* CONFIG_ADEOS_CORE */
 	unsigned long saved_tpr;
 #ifdef CONFIG_SMP
 #	define IS_RESCHEDULE(vec)	(vec == IA64_IPI_RESCHEDULE)
@@ -135,7 +154,10 @@ ia64_handle_irq (ia64_vector vector, str
 	 * 16 (without this, it would be ~240, which could easily lead
 	 * to kernel stack overflows).
 	 */
+#ifndef CONFIG_ADEOS_CORE
+	/* Leave this to do_IRQ(). */
 	irq_enter();
+#endif /* !CONFIG_ADEOS_CORE */
 	saved_tpr = ia64_getreg(_IA64_REG_CR_TPR);
 	ia64_srlz_d();
 	while (vector != IA64_SPURIOUS_INT_VECTOR) {
@@ -143,6 +165,41 @@ ia64_handle_irq (ia64_vector vector, str
 			ia64_setreg(_IA64_REG_CR_TPR, vector);
 			ia64_srlz_d();
 
+#ifdef CONFIG_ADEOS_CORE
+			/* Note: we let the critical IPI flow down the
+			   pipeline, even if the latter is not enabled
+			   yet.  This exception case occurs once
+			   during __adeos_enable_pipeline(), and
+			   unless the IRQ is spurious, it must be
+			   related to the adeos_critical_enter()
+			   service. If it is spurious, then the
+			   default Linux handler will catch it
+			   properly anyway. */
+#ifdef CONFIG_SMP
+			if (likely(adp_pipelined || local_vector_to_irq(vector) == ADEOS_CRITICAL_IPI))
+#else /* !CONFIG_SMP */
+			if (likely(adp_pipelined))
+#endif /* CONFIG_SMP */
+			    {
+			    /* Send EOI _before_ running the handlers,
+			       otherwise, we would get massive jitter
+			       in domains pipelined above the Linux
+			       one. */
+			    adeos_hw_cli();
+			    ia64_setreg(_IA64_REG_CR_TPR,saved_tpr);
+			    ia64_eoi();
+			    __adeos_handle_irq(local_vector_to_irq(vector),regs);
+			    goto no_eoi;
+			    }
+
+			do_IRQ(local_vector_to_irq(vector),regs);
+			adeos_hw_cli();
+			ia64_setreg(_IA64_REG_CR_TPR,saved_tpr);
+		}
+		ia64_eoi();
+no_eoi:
+		adeos_load_cpuid(); /* Processor might have changed. */
+#else /* !CONFIG_ADEOS_CORE */
 			do_IRQ(local_vector_to_irq(vector), regs);
 
 			/*
@@ -152,6 +209,7 @@ ia64_handle_irq (ia64_vector vector, str
 			ia64_setreg(_IA64_REG_CR_TPR, saved_tpr);
 		}
 		ia64_eoi();
+#endif /* CONFIG_ADEOS_CORE */
 		vector = ia64_get_ivr();
 	}
 	/*
@@ -159,7 +217,11 @@ ia64_handle_irq (ia64_vector vector, str
 	 * handler needs to be able to wait for further keyboard interrupts, which can't
 	 * come through until ia64_eoi() has been done.
 	 */
+#ifdef CONFIG_ADEOS_CORE
+        return (adp_cpu_current[cpuid] == adp_root && !test_bit(IPIPE_STALL_FLAG,&adp_root->cpudata[cpuid].status));
+#else /* !CONFIG_ADEOS_CORE */
 	irq_exit();
+#endif /* CONFIG_ADEOS_CORE */
 }
 
 #ifdef CONFIG_SMP
@@ -221,5 +283,14 @@ ia64_send_ipi (int cpu, int vector, int 
 	ipi_data = (delivery_mode << 8) | (vector & 0xff);
 	ipi_addr = ipi_base_addr | (phys_cpu_id << 4) | ((redirect & 1)  << 3);
 
+#ifdef CONFIG_ADEOS_CORE
+	{
+	unsigned long flags;
+	adeos_hw_local_irq_save(flags);
+#endif /* CONFIG_ADEOS_CORE*/
 	writeq(ipi_data, ipi_addr);
+#ifdef CONFIG_ADEOS_CORE
+	adeos_hw_local_irq_restore(flags);
+	}
+#endif /* CONFIG_ADEOS_CORE*/
 }
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/ivt.S linux-2.6.6-ia64-adeos/arch/ia64/kernel/ivt.S
--- linux-2.6.6-ia64/arch/ia64/kernel/ivt.S	2004-06-17 11:19:11.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/ivt.S	2004-06-17 11:45:45.000000000 +0200
@@ -735,11 +735,26 @@ ENTRY(break_fault)
 	;;
 (p15)	ssm psr.i				// restore psr.i
 	;;
+#ifdef CONFIG_ADEOS_CORE
+#if PT(B6) != 0
+# error This code assumes that b6 is the first field in pt_regs.
+#endif
+	;; 
+	adds r20=PT(B6)+16,sp			// r20 = &pt_regs
+	br.call.sptk.many b6=__adeos_catch_syscall
+	cmp.eq p0,p7=r8,r0
+(p7)	br.cond.spnt __adeos_bypass_syscall
+	;; 
+#endif /* CONFIG_ADEOS_CORE */
 	mov r3=NR_syscalls - 1
 	movl r16=sys_call_table
 
 	adds r15=-1024,r15			// r15 contains the syscall number---subtract 1024
+#ifdef CONFIG_ADEOS_CORE
+	movl r2=__adeos_ret_from_syscall
+#else /* !CONFIG_ADEOS_CORE */
 	movl r2=ia64_ret_from_syscall
+#endif /* CONFIG_ADEOS_CORE */
 	;;
 	shladd r20=r15,3,r16			// r20 = sys_call_table + 8*(syscall-1024)
 	cmp.leu p6,p7=r15,r3			// (syscall > 0 && syscall < 1024 + NR_syscalls) ?
@@ -780,7 +795,11 @@ ENTRY(interrupt)
 	add out1=16,sp		// pass pointer to pt_regs as second arg
 	;;
 	srlz.d			// make sure we see the effect of cr.ivr
+#ifdef CONFIG_ADEOS_CORE
+	movl r14=__adeos_ret_from_intr
+#else /* !CONFIG_ADEOS_CORE */
 	movl r14=ia64_leave_kernel
+#endif /* CONFIG_ADEOS_CORE */
 	;;
 	mov rp=r14
 	br.call.sptk.many b6=ia64_handle_irq
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/process.c linux-2.6.6-ia64-adeos/arch/ia64/kernel/process.c
--- linux-2.6.6-ia64/arch/ia64/kernel/process.c	2004-06-17 11:19:11.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/process.c	2004-06-17 11:45:45.000000000 +0200
@@ -150,6 +150,32 @@ do_notify_resume_user (sigset_t *oldset,
 		return;
 	}
 
+#ifdef CONFIG_ADEOS_CORE
+	/* Virtualizing all changes to psr.i (i.e. cli/sti) in entry.S
+	   for the ia64 arch would be clearly sub-optimal, without
+	   even any guarantee to get significantly better
+	   preemptability. For instance, preserving the scratch
+	   registers while calling the Adeos pipeline management would
+	   eat quite a few cycles and probably create much of a
+	   burden. It has been decided instead to selectively
+	   re-enable hardware interrupts for the C routines called
+	   from entry.S which are known to be invoked with interrupts
+	   off, while keeping the Linux domain stalled. This current
+	   routine is currently the only one which seems worth hacking
+	   this way. After a not so brief inspection, we assume that
+	   all return paths in entry.S never lock out the hardware
+	   interrupts for an unreasonably long time. However, in case
+	   of jitter, a potential source of such problem might be the
+	   recursive code cleaning up the stacked registers that
+	   starts from "dont_preserve_current_frame" in entry.S. */
+	{
+	unsigned long flags, _flags;
+	adeos_declare_cpuid;
+
+	flags = __adeos_test_and_stall_root();
+	adeos_hw_sti();
+#endif /* CONFIG_ADEOS_CORE */
+
 #ifdef CONFIG_PERFMON
 	if (current->thread.pfm_needs_checking)
 		pfm_handle_work();
@@ -158,6 +184,13 @@ do_notify_resume_user (sigset_t *oldset,
 	/* deal with pending signal delivery */
 	if (test_thread_flag(TIF_SIGPENDING))
 		ia64_do_signal(oldset, scr, in_syscall);
+
+#ifdef CONFIG_ADEOS_CORE
+	adeos_lock_cpu(_flags);
+	adeos_restore_pipeline_nosync(adp_root,flags,cpuid);
+	adeos_unlock_cpu(_flags);
+	}
+#endif /* CONFIG_ADEOS_CORE */
 }
 
 static int pal_halt = 1;
@@ -200,6 +233,9 @@ cpu_idle (void *unused)
 		while (!need_resched()) {
 			if (mark_idle)
 				(*mark_idle)(1);
+#ifdef CONFIG_ADEOS_CORE
+			adeos_suspend_domain();
+#endif /* CONFIG_ADEOS_CORE */
 			(*idle)();
 		}
 
@@ -619,6 +655,9 @@ kernel_thread_helper (int (*fn)(void *),
 		ia64_set_kr(IA64_KR_TSSD, current->thread.old_k1);
 	}
 #endif
+#ifdef CONFIG_ADEOS_CORE
+	__adeos_unstall_root();
+#endif /* CONFIG_ADEOS_CORE */
 	return (*fn)(arg);
 }
 
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/time.c linux-2.6.6-ia64-adeos/arch/ia64/kernel/time.c
--- linux-2.6.6-ia64/arch/ia64/kernel/time.c	2004-06-13 12:29:08.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/time.c	2004-06-17 11:45:45.000000000 +0200
@@ -246,7 +246,19 @@ timer_interrupt (int irq, void *dev_id, 
 
 	platform_timer_interrupt(irq, dev_id, regs);
 
-	new_itm = local_cpu_data->itm_next;
+#ifdef CONFIG_ADEOS_CORE
+	if (likely(adp_pipelined))
+	    {
+	    adeos_declare_cpuid;
+	    unsigned long flags;
+
+	    adeos_get_cpu(flags);
+	    new_itm = __adeos_itm_next[cpuid] - __adeos_itm_delta[cpuid];
+	    adeos_put_cpu(flags);
+	    }
+	else
+#endif /* CONFIG_ADEOS_CORE */
+	    new_itm = local_cpu_data->itm_next;
 
 	if (!time_after(ia64_get_itc(), new_itm))
 		printk(KERN_ERR "Oops: timer tick before it's due (itc=%lx,itm=%lx)\n",
@@ -254,6 +266,7 @@ timer_interrupt (int irq, void *dev_id, 
 
 	ia64_do_profile(regs);
 
+
 	while (1) {
 #ifdef CONFIG_SMP
 		/*
@@ -283,6 +296,9 @@ timer_interrupt (int irq, void *dev_id, 
 			break;
 	}
 
+#ifdef CONFIG_ADEOS_CORE
+	if (!adp_pipelined)
+#endif /* CONFIG_ADEOS_CORE */
 	do {
 		/*
 		 * If we're too close to the next clock tick for
diff -uNrp linux-2.6.6-ia64/include/asm-ia64/adeos.h linux-2.6.6-ia64-adeos/include/asm-ia64/adeos.h
--- linux-2.6.6-ia64/include/asm-ia64/adeos.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.6-ia64-adeos/include/asm-ia64/adeos.h	2004-06-17 11:46:40.000000000 +0200
@@ -0,0 +1,364 @@
+/*
+ *   include/asm-ia64/adeos.h
+ *
+ *   Copyright (C) 2003,2004 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+
+#ifndef __IA64_ADEOS_H
+#define __IA64_ADEOS_H
+
+#include <asm/types.h>
+#include <asm/siginfo.h>
+#include <asm/ptrace.h>
+#include <asm/irq.h>
+#include <linux/list.h>
+#include <linux/threads.h>
+
+#define ADEOS_ARCH_STRING "ia64"
+
+extern int adp_pipelined;
+
+#ifdef CONFIG_SMP
+
+#include <asm/smp.h>
+#include <asm/gcc_intrin.h>
+
+#define ADEOS_NR_CPUS          NR_CPUS
+#define ADEOS_SERVICE_VECTOR   0xf1
+#define ADEOS_SERVICE_IPI      local_vector_to_irq(ADEOS_SERVICE_VECTOR)
+#define ADEOS_CRITICAL_VECTOR  0xf9 /* Used by adeos_critical_enter/exit() */
+#define ADEOS_CRITICAL_IPI     local_vector_to_irq(ADEOS_CRITICAL_VECTOR)
+
+/* Use Linux's dense CPU identifiers here -- referencing "current" on
+   ia64 is always safe, regardless of the calling context. */
+#define adeos_processor_id()   smp_processor_id()
+
+#define adeos_declare_cpuid    int cpuid
+#define adeos_load_cpuid()     do { \
+                                  (cpuid) = adeos_processor_id();	\
+                               } while(0)
+#define adeos_lock_cpu(flags)  do { \
+                                  adeos_hw_local_irq_save(flags); \
+				  ia64_stop();			  \
+                                  (cpuid) = adeos_processor_id(); \
+                               } while(0)
+#define adeos_unlock_cpu(flags) adeos_hw_local_irq_restore(flags)
+#define adeos_get_cpu(flags)    adeos_lock_cpu(flags)
+#define adeos_put_cpu(flags)    adeos_unlock_cpu(flags)
+#define adp_current            ({ adomain_t *__adp; \
+				unsigned long flags; \
+				adeos_hw_local_irq_save(flags); \
+				ia64_stop();			\
+				__adp = adp_cpu_current[adeos_processor_id()]; \
+				adeos_hw_local_irq_restore(flags); \
+				__adp; })
+#else  /* !CONFIG_SMP */
+
+#define ADEOS_NR_CPUS          1
+#define adeos_processor_id()   0
+/* Array references using this index should be optimized out. */
+#define adeos_declare_cpuid    const int cpuid = 0
+#define adeos_load_cpuid()      /* nop */
+#define adeos_lock_cpu(flags)   adeos_hw_local_irq_save(flags)
+#define adeos_unlock_cpu(flags) adeos_hw_local_irq_restore(flags)
+#define adeos_get_cpu(flags)    do { flags = flags; } while(0)
+#define adeos_put_cpu(flags)    /* nop */
+#define adp_current             (adp_cpu_current[0])
+
+#endif /* CONFIG_SMP */
+
+ /* IDT fault vectors */
+#define ADEOS_NR_FAULTS         32
+/* Pseudo-vectors used for kernel events */
+#define ADEOS_FIRST_KEVENT      ADEOS_NR_FAULTS
+#define ADEOS_SYSCALL_PROLOGUE  (ADEOS_FIRST_KEVENT)
+#define ADEOS_SYSCALL_EPILOGUE  (ADEOS_FIRST_KEVENT + 1)
+#define ADEOS_SCHEDULE_HEAD     (ADEOS_FIRST_KEVENT + 2)
+#define ADEOS_SCHEDULE_TAIL     (ADEOS_FIRST_KEVENT + 3)
+#define ADEOS_ENTER_PROCESS     (ADEOS_FIRST_KEVENT + 4)
+#define ADEOS_EXIT_PROCESS      (ADEOS_FIRST_KEVENT + 5)
+#define ADEOS_SIGNAL_PROCESS    (ADEOS_FIRST_KEVENT + 6)
+#define ADEOS_KICK_PROCESS      (ADEOS_FIRST_KEVENT + 7)
+#define ADEOS_RENICE_PROCESS    (ADEOS_FIRST_KEVENT + 8)
+#define ADEOS_USER_EVENT        (ADEOS_FIRST_KEVENT + 9)
+#define ADEOS_LAST_KEVENT       (ADEOS_USER_EVENT)
+
+#define ADEOS_NR_EVENTS         (ADEOS_LAST_KEVENT + 1)
+
+typedef struct adevinfo {
+
+    unsigned domid;
+    unsigned event;
+    void *evdata;
+
+    int propagate;		/* Private */
+
+} adevinfo_t;
+
+typedef struct adsysinfo {
+
+    int ncpus;			/* Number of CPUs on board */
+
+    u64 cpufreq;		/* CPU frequency (in Hz) */
+
+    /* Arch-dependent block */
+
+    struct {
+	unsigned tmirq;		/* Timer tick IRQ */
+    } archdep;
+
+} adsysinfo_t;
+
+#define IPIPE_NR_XIRQS   NR_IRQS
+/* Number of virtual IRQs */
+#define IPIPE_NR_VIRQS   BITS_PER_LONG
+/* First virtual IRQ # */
+#define IPIPE_VIRQ_BASE  (((IPIPE_NR_XIRQS + BITS_PER_LONG - 1) / BITS_PER_LONG) * BITS_PER_LONG)
+/* Total number of IRQ slots */
+#define IPIPE_NR_IRQS     (IPIPE_VIRQ_BASE + IPIPE_NR_VIRQS)
+/* Number of indirect words needed to map the whole IRQ space. */
+#define IPIPE_IRQ_IWORDS  ((IPIPE_NR_IRQS + BITS_PER_LONG - 1) / BITS_PER_LONG)
+#define IPIPE_IRQ_IMASK   (BITS_PER_LONG - 1)
+#define IPIPE_IRQ_ISHIFT  6	/* 2^6 for 64 bits arch. */
+
+#define IPIPE_IRQMASK_ANY   (~0L)
+#define IPIPE_IRQMASK_VIRT  (IPIPE_IRQMASK_ANY << (IPIPE_VIRQ_BASE / BITS_PER_LONG))
+
+typedef struct adomain {
+
+    /* -- Section: offset-based references are made on these fields
+       from inline assembly code. Please don't move or reorder. */
+    void (*dswitch)(void);	/* Domain switch hook */
+    unsigned long esp[ADEOS_NR_CPUS];	/* Domain stack pointers */
+    /* -- End of section. */
+
+    unsigned long estackbase[ADEOS_NR_CPUS];
+
+    unsigned long flags;
+
+    unsigned domid;
+
+    const char *name;
+
+    int priority;
+
+    struct adcpudata {
+	volatile unsigned long status;
+	volatile unsigned long irq_pending_hi;
+	volatile unsigned long irq_pending_lo[IPIPE_IRQ_IWORDS];
+	volatile unsigned long irq_hits[IPIPE_NR_IRQS];
+	adevinfo_t event_info;
+    } cpudata[ADEOS_NR_CPUS];
+
+    struct {
+	int (*acknowledge)(unsigned irq);
+	void (*handler)(unsigned irq);
+	unsigned long control;
+    } irqs[IPIPE_NR_IRQS];
+
+    struct {
+	void (*handler)(adevinfo_t *evinfo);
+    } events[ADEOS_NR_EVENTS];
+
+    int ptd_keymax;
+    int ptd_keycount;
+    unsigned long ptd_keymap;
+    void (*ptd_setfun)(int, void *);
+    void *(*ptd_getfun)(int);
+
+    struct adomain *m_link;	/* Link in mutex sleep queue */
+
+    struct list_head p_link;	/* Link in pipeline */
+
+} adomain_t;
+
+/* The following macros must be used hw interrupts off. */
+
+#define __adeos_set_irq_bit(adp,cpuid,irq) \
+do { \
+    if (!test_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) { \
+        __set_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+        __set_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[cpuid].irq_pending_hi); \
+       } \
+} while(0)
+
+#define __adeos_clear_pend(adp,cpuid,irq) \
+do { \
+    __clear_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+    if (&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT] == 0) \
+        __clear_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[cpuid].irq_pending_hi); \
+} while(0)
+
+#define __adeos_lock_irq(adp,cpuid,irq) \
+do { \
+    if (!test_and_set_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) \
+	__adeos_clear_pend(adp,cpuid,irq); \
+} while(0)
+
+#define __adeos_unlock_irq(adp,irq) \
+do { \
+    int __cpuid, __nr_cpus = num_online_cpus();			       \
+    if (test_and_clear_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) \
+	for (__cpuid = 0; __cpuid < __nr_cpus; __cpuid++)      \
+         if ((adp)->cpudata[__cpuid].irq_hits[irq] > 0) { \
+           set_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[__cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+           set_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[__cpuid].irq_pending_hi); \
+         } \
+} while(0)
+
+#define __adeos_clear_irq(adp,irq) \
+do { \
+    int __cpuid, __nr_cpus = num_online_cpus(); \
+    clear_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control); \
+    for (__cpuid = 0; __cpuid < __nr_cpus; __cpuid++) {	\
+       (adp)->cpudata[__cpuid].irq_hits[irq] = 0; \
+       __adeos_clear_pend(adp,__cpuid,irq); \
+    } \
+} while(0)
+
+#define adeos_virtual_irq_p(irq) ((irq) >= IPIPE_VIRQ_BASE && \
+				  (irq) < IPIPE_NR_IRQS)
+
+#define adeos_hw_cli()		\
+do {				\
+	ia64_stop();		\
+	ia64_rsm(IA64_PSR_I);	\
+} while (0)
+
+#define adeos_hw_sti() ({ ia64_ssm(IA64_PSR_I); ia64_srlz_d(); })
+
+#define adeos_hw_save_flags_and_sti(x)	\
+do {                                    \
+    (x) = ia64_getreg(_IA64_REG_PSR);   \
+    adeos_hw_sti();                     \
+} while(0)
+
+#define adeos_hw_local_irq_save(x)	\
+do {					\
+	unsigned long __psr;		\
+        __psr = ia64_getreg(_IA64_REG_PSR);	\
+        ia64_stop();				\
+        ia64_rsm(IA64_PSR_I);			\
+	(x) = __psr;				\
+} while (0)
+      
+#define adeos_hw_local_irq_restore(x) \
+    ia64_intrin_local_irq_restore((x) & IA64_PSR_I)
+
+#define adeos_hw_local_irq_flags(x)   ((x) = ia64_getreg(_IA64_REG_PSR))
+#define adeos_hw_test_iflag(x) 	      ((x) & IA64_PSR_I)
+#define adeos_hw_irqs_disabled()	 \
+    ({					 \
+	unsigned long flags;		 \
+	adeos_hw_local_irq_flags(flags); \
+	!adeos_hw_test_iflag(flags);	 \
+    })
+
+#define adeos_hw_tsc(t)  __asm__ __volatile__("mov %0=ar.itc;;" : "=r"(t) :: "memory")
+#define adeos_cpu_freq() local_cpu_data->proc_freq
+
+#ifdef CONFIG_PREEMPT
+#define adeos_spin_lock(x)    _raw_spin_lock(x)
+#define adeos_spin_unlock(x)  _raw_spin_unlock(x)
+#define adeos_spin_trylock(x) _raw_spin_trylock(x)
+#else /* !CONFIG_PREEMPT */
+#define adeos_spin_lock(x)    spin_lock(x)
+#define adeos_spin_unlock(x)  spin_unlock(x)
+#define adeos_spin_trylock(x) spin_trylock(x)
+#endif /* CONFIG_PREEMPT */
+
+#define adeos_spin_lock_irqsave(x,flags)       do { adeos_hw_local_irq_save(flags); adeos_spin_lock(x); } while (0)
+#define adeos_spin_unlock_irqrestore(x,flags)  do { adeos_spin_unlock(x); adeos_hw_local_irq_restore(flags); } while (0)
+#define adeos_spin_lock_disable(x)             do { adeos_hw_cli(); adeos_spin_lock(x); } while (0)
+#define adeos_spin_unlock_enable(x)            do { adeos_spin_unlock(x); adeos_hw_sti(); } while (0)
+
+#ifndef STR
+#define __STR(x) #x
+#define STR(x) __STR(x)
+#endif
+
+#ifndef SYMBOL_NAME_STR
+#define SYMBOL_NAME_STR(X) #X
+#endif
+
+/* Private interface -- Internal use only */
+
+struct adattr;
+
+void __adeos_init(void);
+
+#define __adeos_check_machine() do { } while(0)
+
+void __adeos_init_domain(adomain_t *adp,
+			 struct adattr *attr);
+
+void __adeos_cleanup_domain(adomain_t *adp);
+
+void __adeos_send_IPI_allbutself(int vector);
+
+void __adeos_send_IPI_other(int cpu,
+			    int vector);
+
+int __adeos_fork_domain(unsigned long stacktop);
+
+void __adeos_switch_to(adomain_t *adp,
+		       int cpuid);
+
+#ifdef CONFIG_SMP
+
+unsigned long __adeos_set_irq_affinity(unsigned irq,
+				       unsigned long cpumask);
+
+#endif /* CONFIG_SMP */
+
+void __adeos_enable_pipeline(void);
+
+void __adeos_disable_pipeline(void);
+
+void __adeos_init_stage(adomain_t *adp);
+
+void __adeos_sync_stage(unsigned long syncmask);
+
+int __adeos_ack_system_irq(unsigned irq);
+
+void __adeos_handle_irq(long irq,
+			struct pt_regs *regs);
+
+extern struct list_head __adeos_pipeline;
+
+extern struct pt_regs __adeos_tick_regs;
+
+extern int __adeos_tick_irq;
+
+extern volatile unsigned long __adeos_itm_next[];
+
+extern volatile unsigned long __adeos_itm_delta[];
+
+#define ADEOS_DEBUG 1
+
+#ifdef ADEOS_DEBUG
+
+void __adeos_set_mark(int id);
+
+void __adeos_dump_marks(void);
+
+void __adeos_clear_marks(void);
+
+#endif /* ADEOS_DEBUG */
+
+#endif /* !__IA64_ADEOS_H */
diff -uNrp linux-2.6.6-ia64/include/asm-ia64/system.h linux-2.6.6-ia64-adeos/include/asm-ia64/system.h
--- linux-2.6.6-ia64/include/asm-ia64/system.h	2004-06-17 11:19:12.000000000 +0200
+++ linux-2.6.6-ia64-adeos/include/asm-ia64/system.h	2004-06-17 11:45:45.000000000 +0200
@@ -107,6 +107,39 @@ extern struct ia64_boot_param {
 
 #define safe_halt()         ia64_pal_halt_light()    /* PAL_HALT_LIGHT */
 
+#ifdef CONFIG_ADEOS_CORE
+
+extern inline void __adeos_stall_root(void);
+
+extern inline void __adeos_unstall_root(void);
+
+extern inline unsigned long __adeos_test_root(void);
+
+extern inline unsigned long __adeos_test_and_stall_root(void);
+
+void __adeos_restore_root(unsigned long flags);
+
+#define __local_irq_save(x)    ((x) = __adeos_test_and_stall_root())
+
+#define __local_irq_disable() 	__adeos_stall_root()
+
+#define __local_irq_restore(x)	__adeos_restore_root(x)
+
+#ifdef CONFIG_IA64_DEBUG_IRQ
+#error "ADEOS: no support for IRQ debug mode"
+#endif /* CONFIG_IA64_DEBUG_IRQ */
+
+#define local_irq_save(x)	__local_irq_save(x)
+#define local_irq_disable()	__local_irq_disable()
+#define local_irq_restore(x)	__local_irq_restore(x)
+
+#define local_irq_enable()	__adeos_unstall_root()
+#define local_save_flags(x)	((x) = __adeos_test_root())
+
+#define irqs_disabled()		__adeos_test_root()
+
+#else /* !CONFIG_ADEOS_CORE */
+
 /*
  * The group barrier in front of the rsm & ssm are necessary to ensure
  * that none of the previous instructions in the same group are
@@ -181,6 +214,8 @@ do {								\
 	(__ia64_id_flags & IA64_PSR_I) == 0;	\
 })
 
+#endif /* CONFIG_ADEOS_CORE */
+
 #ifdef __KERNEL__
 
 #define prepare_to_switch()    do { } while(0)
@@ -222,15 +257,38 @@ extern void ia64_load_extra (struct task
 	((t)->thread.flags & (IA64_THREAD_DBG_VALID|IA64_THREAD_PM_VALID)	\
 	 || IS_IA32_PROCESS(ia64_task_regs(t)) || PERFMON_IS_SYSWIDE())
 
-#define __switch_to(prev,next,last) do {							 \
-	if (IA64_HAS_EXTRA_STATE(prev))								 \
-		ia64_save_extra(prev);								 \
-	if (IA64_HAS_EXTRA_STATE(next))								 \
-		ia64_load_extra(next);								 \
-	ia64_psr(ia64_task_regs(next))->dfh = !ia64_is_local_fpu_owner(next);			 \
-	(last) = ia64_switch_to((next));							 \
+#ifdef CONFIG_ADEOS_CORE
+
+#define get_current_gp(t)            __asm__ __volatile__(";;mov %0=r1;;" : "=r"(t) :: "memory")
+#define set_current_gp(t)            __asm__ __volatile__("mov r1=%0;;" :: "r"(t) : "memory")
+
+#define __switch_to(prev,next,last) do {				\
+	volatile unsigned long gp;					\
+	if (IA64_HAS_EXTRA_STATE(prev))					\
+		ia64_save_extra(prev);					\
+	if (IA64_HAS_EXTRA_STATE(next))					\
+		ia64_load_extra(next);					\
+	ia64_psr(ia64_task_regs(next))->dfh = !ia64_is_local_fpu_owner(next); \
+	get_current_gp(gp);						\
+	(last) = ia64_switch_to((next));				\
+	set_current_gp(gp);						\
+} while (0)
+
+#else  /* !CONFIG_ADEOS_CORE */
+
+#define __switch_to(prev,next,last) do {				\
+	volatile unsigned long gp;					\
+	if (IA64_HAS_EXTRA_STATE(prev))					\
+		ia64_save_extra(prev);					\
+	if (IA64_HAS_EXTRA_STATE(next))					\
+		ia64_load_extra(next);					\
+	ia64_psr(ia64_task_regs(next))->dfh = !ia64_is_local_fpu_owner(next); \
+	(last) = ia64_switch_to((next));				\
+									\
 } while (0)
 
+#endif	/* CONFIG_ADEOS_CORE */
+
 #ifdef CONFIG_SMP
 /*
  * In the SMP case, we save the fph state when context-switching away from a thread that
@@ -274,11 +332,22 @@ extern void ia64_load_extra (struct task
  * of that CPU which will not be released, because there we wait for the
  * tasklist_lock to become available.
  */
+#ifdef CONFIG_ADEOS_CORE
+#define prepare_arch_switch(rq,prev,next) \
+do { \
+    struct { struct task_struct *prev, *next; } arg = { (prev), (next) }; \
+    __adeos_schedule_head(&arg); \
+    adeos_hw_cli(); \
+    spin_lock(&(next)->switch_lock);	\
+    spin_unlock(&(rq)->lock);		\
+} while(0)
+#else /* !CONFIG_ADEOS_CORE */
 #define prepare_arch_switch(rq, next)		\
 do {						\
 	spin_lock(&(next)->switch_lock);	\
 	spin_unlock(&(rq)->lock);		\
 } while (0)
+#endif /* CONFIG_ADEOS_CORE */
 #define finish_arch_switch(rq, prev)	spin_unlock_irq(&(prev)->switch_lock)
 #define task_running(rq, p) 		((rq)->curr == (p) || spin_is_locked(&(p)->switch_lock))
 
